<html>
<head>
<title>OgreException.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreException.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreException_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Exception_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Exception_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderPrefix_8h.html">OgreHeaderPrefix.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;exception&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Backwards compatibility with old assert mode definitions</span>
<a name="l00038"></a>00038 <span class="preprocessor">#if OGRE_RELEASE_ASSERT == 1</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ASSERT_MODE 1</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="comment">// Check for OGRE assert mode</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// RELEASE_EXCEPTIONS mode</span>
<a name="l00045"></a>00045 <span class="preprocessor">#if OGRE_ASSERT_MODE == 1</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#   ifdef _DEBUG</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#       define OgreAssert( a, b ) assert( (a) &amp;&amp; (b) )</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049 <span class="preprocessor">#   else</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#       if OGRE_COMP != OGRE_COMPILER_BORL</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#           define OgreAssert( a, b ) if( !(a) ) OGRE_EXCEPT( Ogre::Exception::ERR_RT_ASSERTION_FAILED, (b), &quot;no function info&quot;)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#       else</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#           define OgreAssert( a, b ) if( !(a) ) OGRE_EXCEPT( Ogre::Exception::ERR_RT_ASSERTION_FAILED, (b), __FUNC__ )</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#       endif</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056 <span class="preprocessor">#   endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 <span class="comment">// EXCEPTIONS mode</span>
<a name="l00059"></a>00059 <span class="preprocessor">#elif OGRE_ASSERT_MODE == 2</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#   if OGRE_COMP != OGRE_COMPILER_BORL</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor">#       define OgreAssert( a, b ) if( !(a) ) OGRE_EXCEPT( Ogre::Exception::ERR_RT_ASSERTION_FAILED, (b), &quot;no function info&quot;)</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor">#       define OgreAssert( a, b ) if( !(a) ) OGRE_EXCEPT( Ogre::Exception::ERR_RT_ASSERTION_FAILED, (b), __FUNC__ )</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>
<a name="l00066"></a>00066 <span class="comment">// STANDARD mode</span>
<a name="l00067"></a>00067 <span class="preprocessor">#else</span>
<a name="l00068"></a><a class="code" href="OgreException_8h.html#a8d9e90638349c941f0cc0af76cad1ae4">00068</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreAssert( a, b ) assert( (a) &amp;&amp; (b) )</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00072"></a>00072 <span class="keyword">namespace </span>Ogre {
<a name="l00092"></a><a class="code" href="classOgre_1_1Exception.html">00092</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a> : <span class="keyword">public</span> std::exception
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094     <span class="keyword">protected</span>:
<a name="l00095"></a><a class="code" href="classOgre_1_1Exception.html#a37322c92e46fa70fb703424f3840a68c">00095</a>         <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1Exception.html#a37322c92e46fa70fb703424f3840a68c">line</a>;
<a name="l00096"></a><a class="code" href="classOgre_1_1Exception.html#a64ee5688b9849cdf716b3d296f9725dc">00096</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Exception.html#a64ee5688b9849cdf716b3d296f9725dc">number</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1Exception.html#ad486aacc5f55a6bfa17248d2141270ec">00097</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Exception.html#ad486aacc5f55a6bfa17248d2141270ec">typeName</a>;
<a name="l00098"></a><a class="code" href="classOgre_1_1Exception.html#a54edba4b99e73bf953b25888ee57b008">00098</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Exception.html#a54edba4b99e73bf953b25888ee57b008">description</a>;
<a name="l00099"></a><a class="code" href="classOgre_1_1Exception.html#a224971e0792a4fa0a718107b6e9074fe">00099</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Exception.html#a224971e0792a4fa0a718107b6e9074fe">source</a>;
<a name="l00100"></a><a class="code" href="classOgre_1_1Exception.html#a976410f50fa11be9550720b240987cf3">00100</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Exception.html#a976410f50fa11be9550720b240987cf3">file</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1Exception.html#a16d671f40618b5ca451a3bcb6c0004f8">00101</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Exception.html#a16d671f40618b5ca451a3bcb6c0004f8">fullDesc</a>;
<a name="l00102"></a>00102     <span class="keyword">public</span>:
<a name="l00108"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29b">00108</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29b" title="Static definitions of error codes.">ExceptionCodes</a> {
<a name="l00109"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29baaeb75efe079b550f380d62d9a0954e71">00109</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29baaeb75efe079b550f380d62d9a0954e71">ERR_CANNOT_WRITE_TO_FILE</a>,
<a name="l00110"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9d61f90f76dd3e119d608876ea5f7957">00110</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9d61f90f76dd3e119d608876ea5f7957">ERR_INVALID_STATE</a>,
<a name="l00111"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba359c10b8abe9abf39f84550a903e4698">00111</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba359c10b8abe9abf39f84550a903e4698">ERR_INVALIDPARAMS</a>,
<a name="l00112"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba55da7c9771a98e7c96c3900028f02703">00112</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba55da7c9771a98e7c96c3900028f02703">ERR_RENDERINGAPI_ERROR</a>,
<a name="l00113"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba932168f4c4ae1a90391233de8a21ab1a">00113</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba932168f4c4ae1a90391233de8a21ab1a">ERR_DUPLICATE_ITEM</a>,
<a name="l00114"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9f57f8f4aefb7fae5fcd69fe155e7003">00114</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9f57f8f4aefb7fae5fcd69fe155e7003">ERR_ITEM_NOT_FOUND</a>,
<a name="l00115"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba65ef64423bae408d90e0af0166bac152">00115</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba65ef64423bae408d90e0af0166bac152">ERR_FILE_NOT_FOUND</a>,
<a name="l00116"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba946e7d147a09d8db65b6143d1d348c99">00116</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba946e7d147a09d8db65b6143d1d348c99">ERR_INTERNAL_ERROR</a>,
<a name="l00117"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29bae8c10c1472a5d4005d1c25adb5e2764d">00117</a>             <a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29bae8c10c1472a5d4005d1c25adb5e2764d">ERR_RT_ASSERTION_FAILED</a>, 
<a name="l00118"></a><a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">00118</a>             ERR_NOT_IMPLEMENTED
<a name="l00119"></a>00119         };
<a name="l00120"></a>00120 
<a name="l00123"></a>00123         <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>( <span class="keywordtype">int</span> number, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; description, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; source );
<a name="l00124"></a>00124 
<a name="l00127"></a>00127         <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>( <span class="keywordtype">int</span> number, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; description, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; source, <span class="keyword">const</span> <span class="keywordtype">char</span>* type, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line );
<a name="l00128"></a>00128 
<a name="l00131"></a>00131         <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>&amp; rhs);
<a name="l00132"></a>00132 
<a name="l00134"></a><a class="code" href="classOgre_1_1Exception.html#a5aeb1d634e6d2dc9e547ff37bd9dc051">00134</a>         <a class="code" href="classOgre_1_1Exception.html#a5aeb1d634e6d2dc9e547ff37bd9dc051" title="Needed for compatibility with std::exception.">~Exception</a>() throw() {}
<a name="l00135"></a>00135 
<a name="l00138"></a>00138         <span class="keywordtype">void</span> operator = (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>&amp; rhs);
<a name="l00139"></a>00139 
<a name="l00150"></a>00150         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getFullDescription(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00154"></a>00154         <span class="keyword">virtual</span> <span class="keywordtype">int</span> getNumber(<span class="keywordtype">void</span>) <span class="keyword">const</span> throw();
<a name="l00155"></a>00155 
<a name="l00158"></a><a class="code" href="classOgre_1_1Exception.html#a01188c597faf46e2637999aa205c1862">00158</a>         virtual const <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;getSource()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> source; }
<a name="l00159"></a>00159 
<a name="l00162"></a><a class="code" href="classOgre_1_1Exception.html#aba00713fb4020d42107dafa6fd89fa57">00162</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;<a class="code" href="classOgre_1_1Exception.html#aba00713fb4020d42107dafa6fd89fa57" title="Gets source file name.">getFile</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> file; }
<a name="l00163"></a>00163 
<a name="l00166"></a><a class="code" href="classOgre_1_1Exception.html#a2d100096583c7973bbf5a1276a49ea4a">00166</a>         <span class="keyword">virtual</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1Exception.html#a2d100096583c7973bbf5a1276a49ea4a" title="Gets line number.">getLine</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> line; }
<a name="l00167"></a>00167 
<a name="l00172"></a><a class="code" href="classOgre_1_1Exception.html#a826483325a2bc7fb7a0950cf127dab62">00172</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;<a class="code" href="classOgre_1_1Exception.html#a826483325a2bc7fb7a0950cf127dab62" title="Returns a string with only the &#39;description&#39; field of this exception.">getDescription</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> description; }
<a name="l00173"></a>00173 
<a name="l00175"></a><a class="code" href="classOgre_1_1Exception.html#a0ad3d38bf239293372eb7512281182df">00175</a>         <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classOgre_1_1Exception.html#a0ad3d38bf239293372eb7512281182df" title="Override std::exception::what.">what</a>() <span class="keyword">const</span> throw() { <span class="keywordflow">return</span> getFullDescription().c_str(); }
<a name="l00176"></a>00176         
<a name="l00177"></a>00177     };
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00186"></a>00186     <span class="keyword">template</span> &lt;<span class="keywordtype">int</span> num&gt;
<a name="l00187"></a><a class="code" href="structOgre_1_1ExceptionCodeType.html">00187</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType</a>
<a name="l00188"></a>00188     {
<a name="l00189"></a><a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">00189</a>         <span class="keyword">enum</span> { <a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a> = num };
<a name="l00190"></a>00190     };
<a name="l00191"></a>00191 
<a name="l00192"></a>00192     <span class="comment">// Specialised exceptions allowing each to be caught specifically</span>
<a name="l00193"></a>00193     <span class="comment">// backwards-compatible since exception codes still used</span>
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="classOgre_1_1UnimplementedException.html">00195</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1UnimplementedException.html">UnimplementedException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a> 
<a name="l00196"></a>00196     {
<a name="l00197"></a>00197     <span class="keyword">public</span>:
<a name="l00198"></a><a class="code" href="classOgre_1_1UnimplementedException.html#a454b97468f2b1f1d935442971bf082ec">00198</a>         <a class="code" href="classOgre_1_1UnimplementedException.html">UnimplementedException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00199"></a>00199             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;UnimplementedException&quot;</span>, inFile, inLine) {}
<a name="l00200"></a>00200     };
<a name="l00201"></a><a class="code" href="classOgre_1_1FileNotFoundException.html">00201</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FileNotFoundException.html">FileNotFoundException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203     <span class="keyword">public</span>:
<a name="l00204"></a><a class="code" href="classOgre_1_1FileNotFoundException.html#ac5774daad7866a3b538731c16ba08faf">00204</a>         <a class="code" href="classOgre_1_1FileNotFoundException.html">FileNotFoundException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00205"></a>00205             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;FileNotFoundException&quot;</span>, inFile, inLine) {}
<a name="l00206"></a>00206     };
<a name="l00207"></a><a class="code" href="classOgre_1_1IOException.html">00207</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1IOException.html">IOException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00208"></a>00208     {
<a name="l00209"></a>00209     <span class="keyword">public</span>:
<a name="l00210"></a><a class="code" href="classOgre_1_1IOException.html#a9cb13ae6d95e203689c43dfe194cf0c7">00210</a>         <a class="code" href="classOgre_1_1IOException.html">IOException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00211"></a>00211             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;IOException&quot;</span>, inFile, inLine) {}
<a name="l00212"></a>00212     };
<a name="l00213"></a><a class="code" href="classOgre_1_1InvalidStateException.html">00213</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InvalidStateException.html">InvalidStateException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00214"></a>00214     {
<a name="l00215"></a>00215     <span class="keyword">public</span>:
<a name="l00216"></a><a class="code" href="classOgre_1_1InvalidStateException.html#ab0379b445379968669795492ba1ef567">00216</a>         <a class="code" href="classOgre_1_1InvalidStateException.html">InvalidStateException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00217"></a>00217             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;InvalidStateException&quot;</span>, inFile, inLine) {}
<a name="l00218"></a>00218     };
<a name="l00219"></a><a class="code" href="classOgre_1_1InvalidParametersException.html">00219</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InvalidParametersException.html">InvalidParametersException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00220"></a>00220     {
<a name="l00221"></a>00221     <span class="keyword">public</span>:
<a name="l00222"></a><a class="code" href="classOgre_1_1InvalidParametersException.html#ac6276640f16c331e952b71f3a174bd8f">00222</a>         <a class="code" href="classOgre_1_1InvalidParametersException.html">InvalidParametersException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00223"></a>00223             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;InvalidParametersException&quot;</span>, inFile, inLine) {}
<a name="l00224"></a>00224     };
<a name="l00225"></a><a class="code" href="classOgre_1_1ItemIdentityException.html">00225</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ItemIdentityException.html">ItemIdentityException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00226"></a>00226     {
<a name="l00227"></a>00227     <span class="keyword">public</span>:
<a name="l00228"></a><a class="code" href="classOgre_1_1ItemIdentityException.html#ae98c4a38b709e81ef21722be30db5060">00228</a>         <a class="code" href="classOgre_1_1ItemIdentityException.html">ItemIdentityException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00229"></a>00229             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;ItemIdentityException&quot;</span>, inFile, inLine) {}
<a name="l00230"></a>00230     };
<a name="l00231"></a><a class="code" href="classOgre_1_1InternalErrorException.html">00231</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InternalErrorException.html">InternalErrorException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00232"></a>00232     {
<a name="l00233"></a>00233     <span class="keyword">public</span>:
<a name="l00234"></a><a class="code" href="classOgre_1_1InternalErrorException.html#a5bc4d45afee8370b1688b13dd6099cb2">00234</a>         <a class="code" href="classOgre_1_1InternalErrorException.html">InternalErrorException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00235"></a>00235             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;InternalErrorException&quot;</span>, inFile, inLine) {}
<a name="l00236"></a>00236     };
<a name="l00237"></a><a class="code" href="classOgre_1_1RenderingAPIException.html">00237</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderingAPIException.html">RenderingAPIException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00238"></a>00238     {
<a name="l00239"></a>00239     <span class="keyword">public</span>:
<a name="l00240"></a><a class="code" href="classOgre_1_1RenderingAPIException.html#aa3f950b457a33a114a74f9b8993a885d">00240</a>         <a class="code" href="classOgre_1_1RenderingAPIException.html">RenderingAPIException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00241"></a>00241             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;RenderingAPIException&quot;</span>, inFile, inLine) {}
<a name="l00242"></a>00242     };
<a name="l00243"></a><a class="code" href="classOgre_1_1RuntimeAssertionException.html">00243</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RuntimeAssertionException.html">RuntimeAssertionException</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>
<a name="l00244"></a>00244     {
<a name="l00245"></a>00245     <span class="keyword">public</span>:
<a name="l00246"></a><a class="code" href="classOgre_1_1RuntimeAssertionException.html#a871fffb1a89b647d78c7581e539363e5">00246</a>         <a class="code" href="classOgre_1_1RuntimeAssertionException.html">RuntimeAssertionException</a>(<span class="keywordtype">int</span> inNumber, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inDescription, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <span class="keyword">const</span> <span class="keywordtype">char</span>* inFile, <span class="keywordtype">long</span> inLine)
<a name="l00247"></a>00247             : <a class="code" href="classOgre_1_1Exception.html" title="When thrown, provides information about an error that has occurred inside the engine.">Exception</a>(inNumber, inDescription, inSource, <span class="stringliteral">&quot;RuntimeAssertionException&quot;</span>, inFile, inLine) {}
<a name="l00248"></a>00248     };
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00260"></a><a class="code" href="classOgre_1_1ExceptionFactory.html">00260</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1ExceptionFactory.html" title="Class implementing dispatch methods in order to construct by-value exceptions of a derived type based...">ExceptionFactory</a>
<a name="l00261"></a>00261     {
<a name="l00262"></a>00262     <span class="keyword">private</span>:
<a name="l00264"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#ac4da3f535cd552d055b53cb041b721e4">00264</a>         <a class="code" href="classOgre_1_1ExceptionFactory.html#ac4da3f535cd552d055b53cb041b721e4" title="Private constructor, no construction.">ExceptionFactory</a>() {}
<a name="l00265"></a>00265     <span class="keyword">public</span>:
<a name="l00266"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">00266</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1UnimplementedException.html">UnimplementedException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00267"></a>00267             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_NOT_IMPLEMENTED&gt;</a> code, 
<a name="l00268"></a>00268             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00269"></a>00269             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00270"></a>00270         {
<a name="l00271"></a>00271             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1UnimplementedException.html">UnimplementedException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00272"></a>00272         }
<a name="l00273"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#a7d063369971312bb2675852a1655759e">00273</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1FileNotFoundException.html">FileNotFoundException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00274"></a>00274             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_FILE_NOT_FOUND&gt;</a> code, 
<a name="l00275"></a>00275             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00276"></a>00276             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00277"></a>00277         {
<a name="l00278"></a>00278             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1FileNotFoundException.html">FileNotFoundException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00279"></a>00279         }
<a name="l00280"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#a3d07b4554fa6cf19b7f411c5e864adf9">00280</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1IOException.html">IOException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00281"></a>00281             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_CANNOT_WRITE_TO_FILE&gt;</a> code, 
<a name="l00282"></a>00282             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00283"></a>00283             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00284"></a>00284         {
<a name="l00285"></a>00285             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1IOException.html">IOException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00286"></a>00286         }
<a name="l00287"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#af622c0d4c88eba3481a5b5141b88095f">00287</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1InvalidStateException.html">InvalidStateException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00288"></a>00288             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_INVALID_STATE&gt;</a> code, 
<a name="l00289"></a>00289             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00290"></a>00290             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00291"></a>00291         {
<a name="l00292"></a>00292             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1InvalidStateException.html">InvalidStateException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00293"></a>00293         }
<a name="l00294"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#a37f17de5fb048014074269bde8774f94">00294</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1InvalidParametersException.html">InvalidParametersException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00295"></a>00295             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_INVALIDPARAMS&gt;</a> code, 
<a name="l00296"></a>00296             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00297"></a>00297             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00298"></a>00298         {
<a name="l00299"></a>00299             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1InvalidParametersException.html">InvalidParametersException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00300"></a>00300         }
<a name="l00301"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#a3f08ea4905d6e0b730a4e00c0724879c">00301</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ItemIdentityException.html">ItemIdentityException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00302"></a>00302             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_ITEM_NOT_FOUND&gt;</a> code, 
<a name="l00303"></a>00303             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00304"></a>00304             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00305"></a>00305         {
<a name="l00306"></a>00306             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ItemIdentityException.html">ItemIdentityException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00307"></a>00307         }
<a name="l00308"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#ac6d7515b9dc9b6b308ece16a8640cb65">00308</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ItemIdentityException.html">ItemIdentityException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00309"></a>00309             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_DUPLICATE_ITEM&gt;</a> code, 
<a name="l00310"></a>00310             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00311"></a>00311             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00312"></a>00312         {
<a name="l00313"></a>00313             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ItemIdentityException.html">ItemIdentityException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00314"></a>00314         }
<a name="l00315"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#a32f4396c0b3f4dce4687200f32c1d5c5">00315</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1InternalErrorException.html">InternalErrorException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00316"></a>00316             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_INTERNAL_ERROR&gt;</a> code, 
<a name="l00317"></a>00317             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00318"></a>00318             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00319"></a>00319         {
<a name="l00320"></a>00320             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1InternalErrorException.html">InternalErrorException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00321"></a>00321         }
<a name="l00322"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#a42609de5fc71629fd505a445b28567c8">00322</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1RenderingAPIException.html">RenderingAPIException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00323"></a>00323             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_RENDERINGAPI_ERROR&gt;</a> code, 
<a name="l00324"></a>00324             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00325"></a>00325             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00326"></a>00326         {
<a name="l00327"></a>00327             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RenderingAPIException.html">RenderingAPIException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00328"></a>00328         }
<a name="l00329"></a><a class="code" href="classOgre_1_1ExceptionFactory.html#adffdbf68438b18ae7819ce9520b5aa7b">00329</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1RuntimeAssertionException.html">RuntimeAssertionException</a> <a class="code" href="classOgre_1_1ExceptionFactory.html#a2a13a97a32a5992f1e82f6c8fb8190fb">create</a>(
<a name="l00330"></a>00330             <a class="code" href="structOgre_1_1ExceptionCodeType.html" title="Template struct which creates a distinct type for each exception code.">ExceptionCodeType&lt;Exception::ERR_RT_ASSERTION_FAILED&gt;</a> code, 
<a name="l00331"></a>00331             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc, 
<a name="l00332"></a>00332             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">long</span> line)
<a name="l00333"></a>00333         {
<a name="l00334"></a>00334             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RuntimeAssertionException.html">RuntimeAssertionException</a>(code.<a class="code" href="structOgre_1_1ExceptionCodeType.html#ace852efbc1f5b578bb5871181941732cadc17c75a1a0536b07eaf5f587918544e">number</a>, desc, src, file, line);
<a name="l00335"></a>00335         }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337     };
<a name="l00338"></a>00338     
<a name="l00339"></a>00339 
<a name="l00340"></a>00340     
<a name="l00341"></a>00341 <span class="preprocessor">#ifndef OGRE_EXCEPT</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span><span class="preprocessor">#define OGRE_EXCEPT(num, desc, src) throw Ogre::ExceptionFactory::create( \</span>
<a name="l00343"></a>00343 <span class="preprocessor">    Ogre::ExceptionCodeType&lt;num&gt;(), desc, src, __FILE__, __LINE__ );</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00345"></a>00345 <span class="preprocessor"></span>
<a name="l00348"></a>00348 } <span class="comment">// Namespace Ogre</span>
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderSuffix_8h.html">OgreHeaderSuffix.h</a>&quot;</span>
<a name="l00351"></a>00351 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
